//CONFIGURES SOMETHING TO DO WITH FLOW METER//
inline void digitalInputWithPullup(byte pin, boolean b) { //-ENABLE PULLUPS FOR FLOW METER
  pinMode(pin, INPUT); //------------------------------------ENABLE PULLUPS FOR FLOW METER
  digitalWrite(pin, b?HIGH:LOW); //--------------------------ENABLE PULLUPS FOR FLOW METER
} //---------------------------------------------------------ENABLE PULLUPS FOR FLOW METER
//CONFIGURES SOMETHING TO DO WITH FLOW METER//

//INCLUDE THESE LIBRARIES//
#include <OneWire.h> //-----------NEEDED BY DALLASTEMPERATURE
#include <DallasTemperature.h> //-NEEDED FOR THEMAL SENSORS
#include <LiquidCrystal.h> //-----NEEDED FOR DISPLAY
#include <SimpleDHT.h> //---------NEEDED FOR DHT22 HUMIDITY-TEMP SENSOR
//INCLUDE THESE LIBRARIES//

//SET PINS//
#define FlowPin 3 //----------PIN CONNECTED TO FLOW METER
const int DispD4 = 4; //------FOR DISPLAY
const int DispD5 = 5; //------FOR DISPLAY
const int DispD6 = 6; //------FOR DISPLAY
const int DispD7 = 7; //------FOR DISPLAY
const int DHT22Pin = 8; //----DHT22 SIGNAL (WITH PULLUP)
#define ONE_WIRE_BUS 9 //-----PIN THE TEMPERATURE SENSORS CONNECT TO (WITH 4.7K PULLUP)
const int DispEN = 10; //-----FOR DISPLAY
const int DispRS = 11; //-----FOR DISPLAY
const int ChillCtrl = 12; //--BRING HIGH TO TURN ON CHILLER
const int FanControl = 13; //-BRING HIGH TO TURN ON EXHAUST FAN
const int RbtnPin = 14; //----RIGHT BUTTON GOES HERE (AKA A0) (LOW=PRESSED)
const int LbtnPin = 15; //----LEFT BUTTON GOES HERE (AKA A1) (LOW=PRESSED)
const int CbtnPin = 16; //----CENTER BUTTON GOES (AKA A2) (LOW=PRESSED)
const int LaserCtrl = 17; //--BRING HIGH TO TURN OFF LASER (AKA A3)
//SET PINS//

//SETUP & START LIBRARIES//
#define TEMPERATURE_PRECISION 9 //------------------------------------CAN BE 9-12, BUT 9 IS FASTEST
OneWire oneWire(ONE_WIRE_BUS); //-------------------------------------STARTS ONEWIRE
DallasTemperature sensors(&oneWire); //-------------------------------STARTS DALLASTEMPERATURE
SimpleDHT22 dht22(DHT22Pin); //---------------------------------------STARTS DHT22 SENSOR
LiquidCrystal lcd(DispRS, DispEN, DispD4, DispD5, DispD6, DispD7); //-STARTS DISPLAY
//SETUP & START LIBRARIES//

//VARIABLES USED IN TESTING ONLY
unsigned long SafetyCheckerStartTimer = 1;
unsigned long SafetyEnforcerStartTimer = 1;
unsigned long MainDisplayStartTimer = 1;
unsigned long DHTReadStartTimer = 1;
unsigned long DallasreadStartTimer = 1;
unsigned long SerialBlastStartTimer = 1;
unsigned long ButtonReadStartTimer = 1;
unsigned long ReadFlowMeterStartTimer = 1;
unsigned long CycleTimer = 1;
unsigned long OldSerialTime = millis();
//VARIABLES USED IN TESTING ONLY


//DEFINE VARIABLES THAT WILL PROBABLY NEED MODIFICATION//
const int LPMMultiplier = 4; //-----MULTIPLIES SMALL VALUE TO GIVE MORE CONTROL
const int FromChillerSensor = 4; //-CORRECT
const int AmbientSensor = 0; //-----CORRECT
const int FromLaserSensor = 2; //---CORRECT I THINK
const int ColdTankSensor = 3; //----CORRECT I THINK
const int WarmTankSensor = 1; //----CORRECT I THINK
const int FlowMeterTimer = 300; //--TIME TO SPEND READING FLOW METER IN MILLISECONDS
const int LongPressCylces = 2; //---NUMBER OF CYCLES TO HOLD BUTTON TO GET LONG PRESS
const int MIN_TEMP = 23; //---------ANY TEMPERATURE AT OR BELOW WILL DISABLE CHILLER
const int MAX_TEMP = 28; //---------ANY TEMPERATURE OVER THIS NUMBER WILL SET ALARM
const int MinFlow = 12; //----------MINIMUM LPM FLOW
const int MessageHoldMs = 1000; //--TIME TO KEEP MESSAGE ON SCREEN (IN ADDITION TO ONE CYCLE)
//DEFINE VARIABLES THAT WILL PROBABLY NEED MODIFICATION//

//DEFINE VARIABLES THAT SHOULDN'T NEED MODIFICATION//
int ErrDetect = 0; //-0: (MAX_TEMP -3) OR LESS / 1: <MIN FLOW / 2: >MAX TEMP
                   //-3: =MAX_TEMP / 4: COLD BUCKET<DEW PNT / 5: =(MAX_TEMP-1)
                   //-6: COLD BUCKET=DEW PNT / 7: =(MAX_TEMP-2)
                   //-8: COLD BUCKET 1C FROM DEW PNT / 10: SOMETHING BELOW MIN_TEMP
int DispMode = 0; //-CURRENT DISPLAY MODE; 0=MAIN, 1=RT LONG, 2=LT LONG, 3=C LONG, 4=RT, 5=LT, 6=C  
int ChillTemp = 99; //--------------------TEMPERATURE FOR CHILLER RETURN LINE
int LaserTemp = 99; //--------------------TEMPERATURE FOR LASER RETURN LINE
int CTankTemp = 99; //--------------------TEMPERATURE FOR COLD WATER TANK
int WTankTemp = 99; //--------------------TEMPERATURE FOR WARM WATER TANK
int AmbTemp = 99; //----------------------AMBIENT AIR TEMPERATURE
int DewPoint = 99; //---------------------CALCULATED DEW POINT BASED ON DHT
int FlowLPM = 0; //-----------------------FLOW METER CALCULATED LPM
int SafeOverride = 1; //------------------1=SAFETY CONTROLS OVERRIDEN, 0=AUTO MODE
int ChillManual = 1; //-------------------MANUAL CHILLER STATUS; 0=AUTO, 1=ON, 2=OFF
boolean ChillOn = true; //--------------STATE USED BY LogicRunner
int LaserOn = 1; //-----------------------STATE USED BY LOGIC, 1=LASER ON (PIN LOW)
int RBstatus = 2; //----------------------RIGHT BUTTON STATUS (PRESS=0)
int LBstatus = 2;; //---------------------LEFT BUTTON STATUS (PRESS=0)
int CBstatus = 2;; //---------------------CENTER BUTTON STATUS (PRESS=0)
int RBLongStat = 0; //--------------------FOR LONG PRESS ROUTINE (LONG PRESS = 1)
int LBLongStat = 0; //--------------------FOR LONG PRESS ROUTINE (LONG PRESS = 1)
int CBLongStat = 0; //--------------------FOR LONG PRESS ROUTINE (LONG PRESS = 1)
float DHTAirTEMP = 99; //-----------------AMBIENT AIR TEMPERATURE FROM DHT
float DHTRelHumid = 99; //----------------RELATIVE HUMIDITY FROM DHT SENSOR
int FlowMeterRPM = 0; //------------------FLOW METER REVS PER MINUTE
unsigned long FlowTimeTotal = 0; //-------NEEDED FOR FLOR METER COUNTER
unsigned long FlowTimerStart = 0; //------NEEDED FOR FLOR METER COUNTER
unsigned long FlowTimerNow = millis(); //-NEEDED FOR FLOR METER COUNTER
int FlowSignal = 0; //--------------------NEEDED FOR FLOR METER COUNTER
boolean FlowMeterLatch1 = false; //-------LATCHES TO PREVENT COUNT STICKING
boolean FlowMeterLatch2 = false; //-------LATCHES TO PREVENT COUNT STICKING
unsigned long FlowMeterCount = 0; //------RAW FLOW METER COUNT
double MATH_TEMP_1 = 0; //----------------FOR DOING CALCULATIONS
double MATH_TEMP_2 = 0; //----------------FOR DOING CALCULATIONS
double MATH_TEMP_3 = 0; //----------------FOR DOING CALCULATIONS
double MATH_TEMP_4 = 0; //----------------FOR DOING CALCULATIONS
double MATH_TEMP_5 = 0; //----------------FOR DOING CALCULATIONS
double MATH_TEMP_6 = 0; //----------------FOR DOING CALCULATIONS
unsigned long MATH_TEMP_7 = 0; //---------FOR DOING CALCULATIONS
int MATH_TEMP_8 = 0; //-------------------FOR DOING CALCULATIONS
int RBLTime = 0; //-----------------------FOR LONG PRESS ROUTINE
int LBLTime = 0; //-----------------------FOR LONG PRESS ROUTINE
int CBLTime = 0; //-----------------------FOR LONG PRESS ROUTINE
//DEFINE VARIABLES THAT SHOULDN'T NEED MODIFICATION//

void setup(void)
{
  Serial.begin(57600); //--------------------START SERIAL COMMUNICATION
  sensors.begin(); //-----------------------START DALLAS TEMPERATURE SENSORS
  sensors.setResolution(TEMPERATURE_PRECISION);
  lcd.begin(20, 2); //----------------------START LCD, SET AS 20 COLUMNS AND 2 ROWS
  digitalInputWithPullup(FlowPin, true); //-SET FLOW METER PIN STATUS
  pinMode(LbtnPin, INPUT); //------------SET PIN STATUS
  pinMode(CbtnPin, INPUT); //----------SET PIN STATUS
  pinMode(RbtnPin, INPUT); //-----------SET PIN STATUS
  pinMode(FanControl, OUTPUT); //-----------SET PIN STATUS
  pinMode(ChillCtrl, OUTPUT); //---------SET PIN STATUS
  pinMode(LaserCtrl, OUTPUT); //---------SET PIN STATUS
  digitalWrite(FanControl, HIGH); //--------LEAVE THIS UNTIL LOGICRUNNER IS WRITTEN
}

void loop(void)
{ 
  ReadFlowMeter();
  ReadDHT();
  ReadDallas();
  ButtonRead();
  DispModeGen();
  SafetyChecker();
  SerialBlaster();
}



//CHILLER & LASER CONTROL STUFF STARTS HERE//
void SafetyChecker(){
  SafetyCheckerStartTimer = millis();//TIMER START
  
  ErrDetect = 0; //-SET TO NO ERROR BY DEFAULT
  
  if ((ChillTemp <= MIN_TEMP) || (LaserTemp <= MIN_TEMP)) {ErrDetect = 10;} //-CHILLER OFF
  if ((CTankTemp <= MIN_TEMP) || (WTankTemp <= MIN_TEMP)) {ErrDetect = 10;} //-IF TOO
  if (AmbTemp <= MIN_TEMP){ErrDetect = 10;} //---------------------------------COLD
  
  if ((CTankTemp - 1) == DewPoint){ErrDetect = 8;} //-COLD BUCKET = (DewPoint + 1)

  if(((ChillTemp + 2) == MAX_TEMP) || ((LaserTemp + 2) == MAX_TEMP)){ErrDetect = 7;} //-TEMP =
  if(((CTankTemp + 2) == MAX_TEMP) || ((WTankTemp + 2) == MAX_TEMP)){ErrDetect = 7;} //-MAX_TEMP
  if(((DewPoint + 2) == MAX_TEMP) || ((AmbTemp + 2) == MAX_TEMP)){ErrDetect = 7;} //----MINUS 2

  if (CTankTemp == DewPoint){ErrDetect = 6;} //-------COLD BUCKET = DewPoint

  if (((ChillTemp + 1) == MAX_TEMP) || ((LaserTemp + 1) == MAX_TEMP)){ErrDetect = 5;} //-TEMP =
  if (((CTankTemp + 1) == MAX_TEMP) || ((WTankTemp + 1) == MAX_TEMP)){ErrDetect = 5;} //-MAX_TEMP
  if (((AmbTemp + 1) == MAX_TEMP) || ((DewPoint + 1) == MAX_TEMP)){ErrDetect = 5;} //----MINUS 1
  
  if (CTankTemp < DewPoint){ErrDetect = 4;} //--------COLD BUCKET COLDER THAN DEW POINT

  if((ChillTemp == MAX_TEMP) || (LaserTemp == MAX_TEMP)){ErrDetect = 3;} //-TEMP
  if((CTankTemp == MAX_TEMP) || (WTankTemp == MAX_TEMP)){ErrDetect = 3;} //-= 
  if((AmbTemp == MAX_TEMP) || (DewPoint == MAX_TEMP)){ErrDetect = 3;} //----MAX_TEMP
    
  if ((ChillTemp > MAX_TEMP) || (LaserTemp > MAX_TEMP)){ErrDetect = 2;} //--SOMETHING
  if ((CTankTemp > MAX_TEMP) || (WTankTemp > MAX_TEMP)){ErrDetect = 2;} //--OVER
  if ((AmbTemp > MAX_TEMP) || (DewPoint > MAX_TEMP)){ErrDetect = 2;} //-----MAX_TEMP

  if (FlowLPM < MinFlow){ErrDetect = 1;} //-----------FLOW IS TOO LOW

MATH_TEMP_7 = millis(); SafetyCheckerStartTimer = MATH_TEMP_7 - SafetyCheckerStartTimer;//TIMER END

SafetyEnforcer();
}

void SafetyEnforcer(){ //-------------------------------------CALLED BY SafetyChecker
    SafetyEnforcerStartTimer = millis();//TIMER START
  if (ErrDetect == 1){LaserOn = 0; ChillOn = false;} //--AUTO SET LASER AND CHILLER STATUS
  if (ErrDetect == 2){LaserOn = 0; ChillOn = true;} //---AUTO SET LASER AND CHILLER STATUS
  if (ErrDetect == 3){LaserOn = 0; ChillOn = true;} //---AUTO SET LASER AND CHILLER STATUS
  if (ErrDetect == 5){LaserOn = 0; ChillOn = true;} //---AUTO SET LASER AND CHILLER STATUS
  if (ErrDetect == 7){LaserOn = 1; ChillOn = true;} //---AUTO SET LASER AND CHILLER STATUS
  if (ErrDetect == 0){LaserOn = 1; ChillOn = true;} //---AUTO SET LASER AND CHILLER STATUS
  if (ErrDetect == 4){LaserOn = 0; ChillOn = false;} //--AUTO SET LASER AND CHILLER STATUS
  if (ErrDetect == 6){LaserOn = 0; ChillOn = false;} //--AUTO SET LASER AND CHILLER STATUS
  if (ErrDetect == 8){LaserOn = 1; ChillOn = false;} //--AUTO SET LASER AND CHILLER STATUS
  if (ErrDetect == 10){LaserOn = 1; ChillOn = false;} //-AUTO SET LASER AND CHILLER STATUS
  if (ChillManual == 1){ChillOn = true;} //--------------OVERRIDE CHILLER STATUS IF NEEDED
  if (ChillManual == 2){ChillOn = false;} //-------------OVERRIDE CHILLER STATUS IF NEEDED
  if (SafeOverride == 1){LaserOn = 1;}  //---------------OVERRIDE LASER STATUS IF NEEDED
  if (ChillOn == true){digitalWrite(ChillCtrl,HIGH);} //-TURNS CHILLER ON
  if (ChillOn == false){digitalWrite(ChillCtrl,LOW);} //-TURNS CHILLER OFF
  if (LaserOn == 1){digitalWrite(LaserCtrl,LOW);} //-----TURNS LASER ON
  if (LaserOn == 0){digitalWrite(LaserCtrl,HIGH);} //----TURNS LASER OFF

  MATH_TEMP_7 = millis(); SafetyEnforcerStartTimer = MATH_TEMP_7 - SafetyEnforcerStartTimer;//TIMER END
}
//CHILLER & LASER CONTROL STUFF ENDS HERE//

//DISPLAY STUFF STARTS HERE//
void DispModeGen(){
  DispMode = 0; //-RESET TO MAIN SCREEN DEFAULT
  if (RBstatus = 0){DispMode = 4;} //--------------------CHANGE DispMode AS NEEDED
  if (LBstatus = 0){DispMode = 5;} //--------------------CHANGE DispMode AS NEEDED
  if (CBstatus = 0){DispMode = 6;} //--------------------CHANGE DispMode AS NEEDED
  if (RBLongStat == 1){DispMode = 1; RBLongStat = 0;} //-CHANGE DispMode AS NEEDED
  if (LBLongStat == 1){DispMode = 2; LBLongStat = 0;} //-CHANGE DispMode AS NEEDED
  if (CBLongStat == 1){DispMode = 3; CBLongStat = 0;} //-CHANGE DispMode AS NEEDED
  if (DispMode == 0){MainDisplay();} //------------------USE DispMode
  if (DispMode == 1){RightLongDisplay();} //-------------USE DispMode
  //if (DispMode == 2){LeftLongDisplay();} //------------USE DispMode
  if (DispMode == 3){CenterLongDisplay();} //------------USE DispMode
  //if (DispMode == 4){RightDisplay();} //---------------USE DispMode
  //if (DispMode == 5){LeftDisplay();} //----------------USE DispMode
  //if (DispMode == 6){CenterDisplay();} //--------------USE DispMode
}

void RightLongDisplay(){
  MATH_TEMP_8 = ChillManual; //-----------PUT IN A DIFFERENT VARIABLE FOR CONVENIENCE
  if (MATH_TEMP_8 == 0){ //---------------START OF IF STATEMENT
    ChillManual = 1; //-------------------CHANGE TO THE NEXT MODE
    lcd.setCursor(0, 0); //---------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
    lcd.print(" CHILLER IS NOW SET "); //-PRINT TEXT
    lcd.setCursor(0, 1); //---------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
    lcd.print(" TO MANUAL ON MODE  "); //-PRINT TEXT
    delay(MessageHoldMs); //--------------HOLD DISPLAY LONG ENOUGH TO BE READ
    } //----------------------------------END OF IF
  if (MATH_TEMP_8 == 1){ //---------------START OF IF STATEMENT
    ChillManual = 2; //-------------------CHANGE TO THE NEXT MODE
    lcd.setCursor(0, 0); //---------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
    lcd.print(" CHILLER IS NOW SET "); //-PRINT TEXT
    lcd.setCursor(0, 1); //---------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
    lcd.print(" TO MANUAL OFF MODE "); //-PRINT TEXT
    delay(MessageHoldMs); //--------------HOLD DISPLAY LONG ENOUGH TO BE READ
    } //----------------------------------END OF IF
  if (MATH_TEMP_8 == 2){ //---------------START OF IF STATEMENT
    ChillManual = 0; //-------------------CHANGE TO THE NEXT MODE
    lcd.setCursor(0, 0); //---------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
    lcd.print(" CHILLER IS NOW SET "); //-PRINT TEXT
    lcd.setCursor(0, 1); //---------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
    lcd.print(" TO AUTOMATIC MODE  "); //-PRINT TEXT
    delay(MessageHoldMs); //--------------HOLD DISPLAY LONG ENOUGH TO BE READ
    } //----------------------------------END OF IF
}

void CenterLongDisplay(){
  if (SafeOverride == 0){SafeOverride = 1;} //-INVERT VARIABLE
  else {SafeOverride = 0;} //------------------INVERT VARIABLE
   
  if (SafeOverride == 1){ //--------------DO THIS IF IT JUST BECAME TRUE
    lcd.setCursor(0, 0); //---------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
    lcd.print("   SAFETY OVERRIDE  "); //-PRINT TEXT
    lcd.setCursor(0, 1); //---------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
    lcd.print("       ENABLED      "); //-PRINT TEXT
    delay(MessageHoldMs); //--------------HOLD DISPLAY LONG ENOUGH TO BE READ
  } //------------------------------------END OF IF
  if (SafeOverride == 0){ //--------------DO THIS IF IT JUST BECAME FALSE
    lcd.setCursor(0, 0); //---------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
    lcd.print("   SAFETY OVERRIDE  "); //-PRINT TEXT
    lcd.setCursor(0, 1); //---------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
    lcd.print("       DISABLED     "); //-PRINT TEXT
    delay(MessageHoldMs); //--------------HOLD DISPLAY LONG ENOUGH TO BE READ
  } //------------------------------------END OF IF
}

void MainDisplay(){
  MainDisplayStartTimer = millis();//START TIMER
  
  lcd.setCursor(0, 0); //---------------------SET DISPLAY POSITION (FIRST CHAR OF FIRST LINE)
  lcd.print(" "); //--------------------------PRINT A SPACE
  if (CTankTemp < 10){lcd.print("0");} //-----ADD LEADING 0 IF NEEDED
  lcd.print(CTankTemp); //--------------------PRINT A TEMPERATURE
  lcd.print("  "); //-------------------------PRINT TWO SPACES
  if (ChillTemp < 10){lcd.print("0");} //-----ADD LEADING 0 IF NEEDED
  lcd.print(ChillTemp); //--------------------PRINT A TEMPERATURE
  lcd.print("  "); //-------------------------PRINT TWO SPACES
  if (AmbTemp < 10){lcd.print("0");} //-------ADD LEADING 0 IF NEEDED
  lcd.print(AmbTemp); //----------------------PRINT A TEMPERATURE
  lcd.print("  "); //-------------------------PRINT TWO SPACES
  if(FlowLPM < 10){lcd.print("0");} //--------ADD LEADING 0 IF NEEDED
  lcd.print(FlowLPM); //----------------------PRINT A TEMPERATURE
  lcd.print("  "); //-------------------------PRINT TWO SPACES
  if (LaserOn == 1){lcd.print("01");} //------PRINT A STATUS (00=OFF, 01=ON)
  if (LaserOn == 0){lcd.print("00");} //------PRINT A STATUS (00=OFF, 01=ON)
  lcd.print(" "); //--------------------------PRINT A SPACE
  lcd.setCursor(0, 1); //---------------------SET DISPLAY POSITION (FIRST CHAR OF SECOND LINE)
  lcd.print(" "); //--------------------------PRINT A SPACE
  if (WTankTemp < 10){lcd.print("0");} //-----ADD LEADING 0 IF NEEDED
  lcd.print(WTankTemp); //--------------------PRINT A TEMPERATURE
  lcd.print("  "); //-------------------------PRINT TWO SPACES
  if (LaserTemp < 10){lcd.print("0");} //-----ADD LEADING 0 IF NEEDED
  lcd.print(LaserTemp); //--------------------PRINT A TEMPERATURE
  lcd.print("  "); //-------------------------PRINT TWO SPACES
  if (DewPoint < 10){lcd.print("0");} //------ADD LEADING 0 IF NEEDED
  lcd.print(DewPoint); //---------------------PRINT A TEMPERATURE
  lcd.print("  "); //-------------------------PRINT TWO SPACES
  if (ChillOn == true){lcd.print("01");} //---PRINT A STATUS (00=OFF, 01=ON)
  if (ChillOn == false){lcd.print("00");} //--PRINT A STATUS (00=OFF, 01=ON)
  lcd.print("  "); //-------------------------PRINT TWO SPACES
  if (SafeOverride == 1){lcd.print("01");} //-PRINT A STATUS (00=OFF, 01=ON)
  if (SafeOverride == 0){lcd.print("00");} //-PRINT A STATUS (00=OFF, 01=ON)
  lcd.print(" "); //--------------------------PRINT A SPACE

MATH_TEMP_7 = millis(); MainDisplayStartTimer = (MATH_TEMP_7 - MainDisplayStartTimer);//END TIMER

//AA = CTankTemp
//BB = WTankTemp
//CC = ChillTemp
//DD = LaserTemp
//EE = AmbTemp
//FF = DewPoint
//GG = FlowLPM
//HH = CHILLER ON/OFF
//II = LASER ON/OFF
//JJ = OVERIDE ON/OFF
//--------------------
//_AA__CC__EE__GG__II_
//_BB__DD__FF__HH__JJ_
//--------------------
}
//DISPLAY STUFF ENDS HERE//

//SENSOR READINGS START HERE//
void ButtonRead(){
  ButtonReadStartTimer = millis();//START TIMER

  RBstatus = digitalRead(RbtnPin); //------------------------------READ BUTTON TO VARIABLE
  LBstatus = digitalRead(LbtnPin); //------------------------------READ BUTTON TO VARIABLE
  CBstatus = digitalRead(CbtnPin); //------------------------------READ BUTTON TO VARIABLE
  if (RBstatus == 0){RBLTime++;} //--------------------------------IF PRESSED, INCRAMENT
  if (LBstatus == 0){LBLTime++;} //--------------------------------IF PRESSED, INCRAMENT
  if (CBstatus == 0){CBLTime++;} //--------------------------------IF PRESSED, INCRAMENT
  if (RBLTime >= LongPressCylces){RBLTime = 0; RBLongStat = 1;} //-IF AT TIME, SET VARIABLE
  if (LBLTime >= LongPressCylces){LBLTime = 0; LBLongStat = 1;} //-IF AT TIME, SET VARIABLE
  if (CBLTime >= LongPressCylces){CBLTime = 0; CBLongStat = 1;} //-IF AT TIME, SET VARIABLE

   MATH_TEMP_7 = millis(); ButtonReadStartTimer = (MATH_TEMP_7 - ButtonReadStartTimer);//END TIMER
}

void ReadDHT(){
  DHTReadStartTimer = millis();;//START TIMER
  DHTAirTEMP = 99; //--------------------------------------SET TO 99 IF ERROR
  DHTRelHumid = 99; //-------------------------------------SET TO 99 IF ERROR
  dht22.read2(&DHTAirTEMP, &DHTRelHumid, NULL);//----------READS SENSOR
  MATH_TEMP_1 = log(DHTRelHumid / 100);//------------------DEW POINT CALCULATION
  MATH_TEMP_2 = ((17.62 * AmbTemp) / (243.5 + AmbTemp));//-DEW POINT CALCULATION
  MATH_TEMP_3 = MATH_TEMP_1 + MATH_TEMP_2;//---------------DEW POINT CALCULATION
  MATH_TEMP_4 = 243.5 * MATH_TEMP_3;//---------------------DEW POINT CALCULATION
  MATH_TEMP_5 = 17.62 - MATH_TEMP_3;//---------------------DEW POINT CALCULATION
  MATH_TEMP_6 = MATH_TEMP_4 / MATH_TEMP_5;//---------------DEW POINT CALCULATION
  DewPoint = (int) MATH_TEMP_6;//--------------------------CONVERT TO INTIGER

  MATH_TEMP_7 = millis();   DHTReadStartTimer = (MATH_TEMP_7 - DHTReadStartTimer);//END TIMER
}

void ReadDallas(){
  DallasreadStartTimer = millis();;//START TIMER
  sensors.requestTemperatures(); //--------------------------READ ALL SENSORS
  ChillTemp = sensors.getTempCByIndex(FromChillerSensor); //-STORE TEMPERATURE
  LaserTemp = sensors.getTempCByIndex(FromLaserSensor); //---STORE TEMPERATURE
  CTankTemp = sensors.getTempCByIndex(ColdTankSensor); //----STORE TEMPERATURE
  WTankTemp = sensors.getTempCByIndex(WarmTankSensor); //----STORE TEMPERATURE
  AmbTemp = sensors.getTempCByIndex(AmbientSensor); //-------STORE TEMPERATURE
  if (ChillTemp < 1){ChillTemp = 99;} //---------------------ERROR CHECKING
  if (LaserTemp < 1){LaserTemp = 99;} //---------------------ERROR CHECKING
  if (CTankTemp < 1){CTankTemp = 99;} //---------------------ERROR CHECKING
  if (WTankTemp < 1){WTankTemp = 99;} //---------------------ERROR CHECKING
  if (AmbTemp < 1){AmbTemp = 99;} //-------------------------ERROR CHECKING
  if (ChillTemp > 99){ChillTemp = 99;} //--------------------ROLLOVER PREVENTION
  if (LaserTemp > 99){LaserTemp = 99;} //--------------------ROLLOVER PREVENTION
  if (CTankTemp > 99){CTankTemp = 99;} //--------------------ROLLOVER PREVENTION
  if (WTankTemp > 99){WTankTemp = 99;} //--------------------ROLLOVER PREVENTION
  if (AmbTemp > 99){AmbTemp = 99;} //------------------------ROLLOVER PREVENTION

  MATH_TEMP_7 = millis(); DallasreadStartTimer = (MATH_TEMP_7 - DallasreadStartTimer);//END TIMER
}

void ReadFlowMeter(){
    ReadFlowMeterStartTimer = millis();;//START TIMER
 
  FlowMeterCount = 0;
  FlowTimerStart = millis(); //---------------------------------SET START TIME TO CURRENT TIME
  FlowTimerNow = millis(); //-----------------------------------UPDATE TIME
  while ((FlowTimerNow - FlowTimerStart) <= FlowMeterTimer){ //-BEGINNING OF WHILE
  FlowSignal = digitalRead(FlowPin); //-------------------------MAGNET PASS SENSOR = HIGH
  if(FlowSignal==1){ //-----------------------------------------TRUE WHEN SENSOR IS HIGH
    FlowMeterLatch1=true; //------------------------------------TRUE WHEN SENSOR IS HIGH
  } //----------------------------------------------------------TRUE WHEN SENSOR IS HIGH
  if(FlowSignal==0){ //-----------------------------------------TRUE WHEN SENSOR IS LOW
    FlowMeterLatch2=true; //------------------------------------TRUE WHEN SENSOR IS LOW
  } //----------------------------------------------------------TRUE WHEN SENSOR IS LOW
  if(FlowMeterLatch1==true and FlowMeterLatch2==true){ //-------IF BOTH ARE TRUE (SPIN DETECTED)
    FlowMeterCount++; //----------------------------------------INCREMENT FLOW METER COUNT
    FlowMeterLatch1=false; //-----------------------------------RESET LATCH
    FlowMeterLatch2=false; //-----------------------------------RESET LATCH
  } //----------------------------------------------------------END OF IF
  FlowTimerNow = millis(); //-----------------------------------UPDATE TIME
  } //----------------------------------------------------------END OF WHILE
  FlowTimeTotal = (FlowTimerNow - FlowTimerStart); //-----------TOTAL TIME SPENT READING THE SENSOR.
  MATH_TEMP_7 = ((FlowMeterCount * 1000000)/ FlowTimeTotal); //-REVS PER MS (USE AS HZ INPUT)
  MATH_TEMP_7 = (MATH_TEMP_7  * 0.232); //----------------------CONVERT hz TO LPM
  MATH_TEMP_7 = ((MATH_TEMP_7 * LPMMultiplier) / 1000); //------FOR MAKING MORE USE OF DISPLAY
  FlowLPM = (int) MATH_TEMP_7; //-------------------------------LPM ROUNDED DOWN
  if (FlowLPM < 1){FlowLPM = 0;} //-----------------------------PREVENT NEGATIVE VALUES
  if (FlowLPM > 99){FlowLPM = 99;} //---------------------------ROLLOVER PROTECTION

     MATH_TEMP_7 = millis(); ReadFlowMeterStartTimer = (MATH_TEMP_7 - ReadFlowMeterStartTimer);//END TIMER
}
//SENSOR READINGS END HERE//

//SERIAL DIAGNOSTIC SENDER STARTS HERE//
void SerialBlaster(){
  SerialBlastStartTimer = millis();//START TIMER
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  Serial.println(" ");
  
 if (DHTAirTEMP < 0){DHTAirTEMP = 0;}
 if (DHTAirTEMP > 99){DHTAirTEMP = 99;}
  Serial.print("DHT_TEMP: ");
 if (DHTAirTEMP < 10){Serial.print("0");}
    Serial.print(DHTAirTEMP);

 if (AmbTemp < 0){AmbTemp = 0;}
 if (AmbTemp > 99){AmbTemp = 99;}
  Serial.print(" Ambient Temp: ");
 if (AmbTemp < 10){Serial.print("0");}
  Serial.print(AmbTemp);

 if (DewPoint < 0){DewPoint = 0;}
 if (DewPoint > 99){DewPoint = 99;}
  Serial.print(" Dew Point: ");
 if (DewPoint < 10){Serial.print("0");}
  Serial.print(DewPoint);

 if (FlowLPM < 0){FlowLPM = 0;}
 if (FlowLPM > 99){FlowLPM = 99;}
  Serial.print(" Flow LPM: ");
 if (FlowLPM < 10){Serial.print("0");}
  Serial.println(FlowLPM);

 if (ChillTemp < 0){ChillTemp = 0;}
 if (ChillTemp > 99){ChillTemp = 99;}
  Serial.print("Chill Temp: ");
 if (ChillTemp < 10){Serial.print("0");}
  Serial.print(ChillTemp);

 if (LaserTemp < 0){LaserTemp = 0;}
 if (LaserTemp > 99){LaserTemp = 99;}
  Serial.print(" Laser Temp: ");
 if (LaserTemp < 10){Serial.print("0");}
  Serial.print(LaserTemp);

 if (CTankTemp < 0){CTankTemp = 0;}
 if (CTankTemp > 99){CTankTemp = 99;}
  Serial.print(" Cold Tank Temp: ");
 if (CTankTemp < 10){Serial.print("0");}
  Serial.print(CTankTemp);

 if (WTankTemp < 0){WTankTemp = 0;}
 if (WTankTemp > 99){WTankTemp = 99;}
  Serial.print(" Warm Tank Temp: ");
 if (WTankTemp < 10){Serial.print("0");}
  Serial.println(WTankTemp);

//---------------------

Serial.print("LEFT-CENTER-RIGHT BUTTONS: ");
  MATH_TEMP_8 = digitalRead(LbtnPin);
  if (MATH_TEMP_8 == 1){Serial.print("OFF");}
  if (MATH_TEMP_8 == 0){Serial.print("ON ");}
  {Serial.print(" ");}
  MATH_TEMP_8 = digitalRead(CbtnPin);
  if (MATH_TEMP_8 == 1){Serial.print("OFF");}
  if (MATH_TEMP_8 == 0){Serial.print("ON ");}
  {Serial.print(" ");}
  MATH_TEMP_8 = digitalRead(RbtnPin);
  if (MATH_TEMP_8 == 1){Serial.println("OFF");}
  if (MATH_TEMP_8 == 0){Serial.println("ON ");}

//---------------------

  Serial.print("DispMode=");
  Serial.print(DispMode);

  Serial.print(" ChillOn=");
  Serial.print(ChillOn);

Serial.print(" ChillManual=");
  Serial.print(ChillManual);

Serial.print(" SafeOverride=");
  Serial.print(SafeOverride);
  
Serial.print(" LaserOn=");
Serial.println(LaserOn);

Serial.println("ErrDetect States: 0: (MAX_TEMP -3) OR LESS / 1: <MIN FLOW / 2: >MAX TEMP");
Serial.println("                  3: =MAX_TEMP / 4: COLD BUCKET<DEW PNT / 5: =(MAX_TEMP-1)");
Serial.println("                  6: COLD BUCKET=DEW PNT / 7: =(MAX_TEMP-2)");
Serial.println("                  8: COLD BUCKET 1C FROM DEW PNT / 10: SOMETHING BELOW MIN_TEMP");

Serial.print("ErrDetect=");
Serial.println(ErrDetect);



  MATH_TEMP_7 = millis(); //-TIMER FOR ENTIRE LOOP
  CycleTimer = (MATH_TEMP_7 - OldSerialTime); //-TIMER FOR ENTIRE LOOP
  OldSerialTime = millis(); //-RESET TIMER FOR ENTIRE LOOP



  
Serial.println("PROGRAM (TOP LINE) TIME USAGE IN MS (LOWER LINE)");
Serial.println("LOOP | SAFEC | SAFEE | MD TIME | DHT TIME | DL TIME | BTN TIME | FLOW TIME");
if (CycleTimer < 1000){Serial.print("0");}
if (CycleTimer < 100){Serial.print("0");}
if (CycleTimer < 10){Serial.print("0");}
Serial.print(CycleTimer);
Serial.print(" | ");
if (SafetyCheckerStartTimer < 1000){Serial.print("0");}
if (SafetyCheckerStartTimer < 100){Serial.print("0");}
if (SafetyCheckerStartTimer < 10){Serial.print("0");}
Serial.print(SafetyCheckerStartTimer);
Serial.print("  | ");
if (SafetyEnforcerStartTimer < 1000){Serial.print("0");}
if (SafetyEnforcerStartTimer < 100){Serial.print("0");}
if (SafetyEnforcerStartTimer < 10){Serial.print("0");}
Serial.print(SafetyEnforcerStartTimer);
Serial.print("  | ");
if (MainDisplayStartTimer < 1000){Serial.print("0");}
if (MainDisplayStartTimer < 100){Serial.print("0");}
if (MainDisplayStartTimer < 10){Serial.print("0");}
Serial.print(MainDisplayStartTimer);
Serial.print("    | ");
if (DHTReadStartTimer < 1000){Serial.print("0");}
if (DHTReadStartTimer < 100){Serial.print("0");}
if (DHTReadStartTimer < 10){Serial.print("0");}
Serial.print(DHTReadStartTimer);
Serial.print("     | ");
if (DallasreadStartTimer < 1000){Serial.print("0");}
if (DallasreadStartTimer < 100){Serial.print("0");}
if (DallasreadStartTimer < 10){Serial.print("0");}
Serial.print(DallasreadStartTimer);
Serial.print("    | ");
if (ButtonReadStartTimer < 1000){Serial.print("0");}
if (ButtonReadStartTimer < 100){Serial.print("0");}
if (ButtonReadStartTimer < 10){Serial.print("0");}
Serial.print(ButtonReadStartTimer);
Serial.print("     | ");
if (ReadFlowMeterStartTimer < 1000){Serial.print("0");}
if (ReadFlowMeterStartTimer < 100){Serial.print("0");}
if (ReadFlowMeterStartTimer < 10){Serial.print("0");}
Serial.println(ReadFlowMeterStartTimer);






MATH_TEMP_7 = millis(); SerialBlastStartTimer = (MATH_TEMP_7 - SerialBlastStartTimer);//END TIMER
Serial.print (" / SerialBlastStartTimer=");
Serial.println (SerialBlastStartTimer);
}
//SERIAL DIAGNOSTIC SENDER ENDS HERE//
